#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
#include "rt_def.h"
#include "rt_func.h"
#include "rt_exter.h"

char *ERROR = "\nError: Asignacin fallida de memoria";


/*FUNCIN PARA ALOCATAR MEMORIA PARA COLOR*/

colorRGB *alocata_Color(void)
{
colorRGB *c;

c = calloc(1,sizeof(colorRGB));
if(!c)
	{
	printf("%s **Color**\n",ERROR);
	getch();
	exit(1);
	}

return(c);
}

/*FUNCIN PARA ALOCATAR MEMORIA PARA VECTOR3D*/

vector3D *alocata_Vector(void)
{
vector3D *v;

v = calloc(1,sizeof(vector3D));
if(!v)
	{
	printf("%s **Vector3D**\n",ERROR);
	getch();
	exit (1);
	}

return(v);
}

/*FUNCIN PARA ALOCATAR MEMORIA PARA VECTOR2D*/

vector2D *alocata_Vector2D(void)
{
vector2D *v;

v = calloc(1,sizeof(vector2D));
if(!v)
	{
	printf("%s **Vector2D**\n",ERROR);
	getch();
	exit (1);
	}

return(v);
}

/*FUNCIN PARA ALOCATAR MEMORIA PARA MATRICES */

matriz4x4 *alocata_Matriz(void)
{
matriz4x4 *m;

m = calloc(1,sizeof(matriz4x4));
if(!m)
	{
	printf("%s **Matriz 3x3**\n",ERROR);
	getch();
	exit (1);
	}
	m->f1 = alocata_Vector();
	m->f2 = alocata_Vector();
	m->f3 = alocata_Vector();
	m->f4 = alocata_Vector();

return(m);
}

/*FUNCIN PARA ALOCATAR MEMORIA PARA RAYOS*/

rayo *alocata_Rayo(void)
{
rayo *r;

r = calloc(1,sizeof(rayo));

if(!r)
	{
	printf("%s **Rayo**\n",ERROR);
	getch();
	exit (1);
	}
	r->origen = alocata_Vector();
	r->dir	 =  alocata_Vector();
	r->color  =  alocata_Color();

return(r);
}

/*FUNCIN PARA ALOCATAR MEMORIA PARA OBJETOS*/

object *alocata_Object(void)
{
object *O;

O = calloc(1,sizeof(object));

if(!O)
	{
	printf("%s **Object**\n",ERROR);
	getch();
	exit (1);
	}
	O->ecuacion			 =  alocata_Matriz();
	O->color_difuso    =  alocata_Color();
	O->color_especular =  alocata_Color();
	O->Ks					 =  alocata_Vector();
	O->Kt					 =  alocata_Vector();

return(O);
}

/*FUNCIN PARA ALOCATAR MEMORIA PARA INTERSECCIONES*/

interseccion *alocata_Interseccion(void)
{
interseccion *i;

i = calloc(1,sizeof(interseccion));

if(!i)
	{
	printf("%s **Interseccion**\n",ERROR);
	getch();
	exit (1);
	}
	i->pto	 = alocata_Vector();
	i->normal = alocata_Vector();
	i->objeto = alocata_Object();

return(i);
}

/*FUNCIN PARA ALOCATAR MEMORIA PARA EL VOLUMEN DE VISIN*/

volumenVision *alocata_VolumenVision(void)
{
volumenVision *vv;

vv	= calloc(1,sizeof(volumenVision));

if(!vv)
	{
	printf("%s **VolumenVision**",ERROR);
	getch();
	exit (1);
	}
	vv->ojo =  alocata_Vector();

return(vv);
}

/*FUNCIN PARA ALOCATAR MEMORIA PARA VECTOR3DESF*/

vector3DEsf *alocata_Vector3DEsf(void)
{
vector3DEsf *v;

v = calloc(1,sizeof(vector3DEsf));
if(!v)
	{
	printf("%s **Vector3DEsf**\n",ERROR);
	getch();
	exit (1);
	}

return(v);
}

/*FUNCIN PARA ALOCATAR MEMORIA PARA LIGHT*/

light *alocata_Light(void)
{
light *l;

l	= calloc(1,sizeof(light));

if(!l)
	{
	printf("%s **Light**",ERROR);
	getch();
	exit (1);
	}
	l->origen 	  = alocata_Vector();
	l->intensidad = alocata_Vector();

return(l);
}

/*FUNCIN PARA ALOCATAR MEMORIA PARA LISTALIGHTS*/

listaLights *alocata_ListaLights(void)
{
listaLights *l;

l	= calloc(1,sizeof(listaLights));

if(!l)
	{
	printf("%s **ListaLights**\n",ERROR);
	getch();
	exit (1);
	}

return(l);
}

/*FUNCIN PARA ALOCATAR MEMORIA PARA LISTAOBJECTS*/

listaObjects *alocata_ListaObjects(void)
{
listaObjects *l;

l	= calloc(1,sizeof(listaObjects));

if(!l)
	{
	printf("%s **ListaObjects**",ERROR);
	getch();
	exit (1);
	}

return(l);
}

/***********************************************************************/

void alocatar_Memoria( void )
{
mcb		   = alocata_Matriz();
inv_mcb		   = alocata_Matriz();
Rayo_Primario      = alocata_Rayo();
r_r 		   = alocata_Rayo();
r_t  		   = alocata_Rayo();
r_s 		   = alocata_Rayo();
intersec	   = alocata_Interseccion();
volVis 		   = alocata_VolumenVision();
OJO 		   = alocata_Vector();	// El ojo esta en el (0,0,0)
ojoEsf      	   = alocata_Vector3DEsf();
puntoPantalla      = alocata_Vector();
luz_Ambiental 	   = alocata_Vector();
R		   = alocata_Vector();
V		   = alocata_Vector();
I		   = alocata_Vector();
tmin_tmax	   = alocata_Vector2D();
color_NEGRO 	   = alocata_Color();
color_Fondo 	   = alocata_Color();
color_Ambiental    = alocata_Color();
color_Difuso       = alocata_Color();
color_Especular    = alocata_Color();
color_MAXIMO	   = alocata_Color();
color_COTA	   = alocata_Color();
Ks		   = alocata_Vector();
Kt		   = alocata_Vector();
s		   = alocata_Vector();

return;
}