#include <stdio.h>
#include <stdlib.h>
#include "rt_def.h"
#include "rt_func.h"
#include "rt_exter.h"


void normaliza_Color(colorRGB *col)
{
switch( recorteColor )
	{
	case CLAMP:
		{
		clamp_RGB(col);
		break;
		}
	case SCALE:
		{
		scale_RGB(col);
		break;
		}
	case CLIP:
		{
		clip_RGB(col);
		break;
		}
	case COTA:
		{
		cota_RGB(col);
		break;
		}
	}

return;
}

void clamp_RGB(colorRGB *col)
{
int flag = 0;

if( (col->r)>1.0 ) { flag = 1; col->r = 1.0; }
if( (col->g)>1.0 ) { flag = 1; col->g = 1.0; }
if( (col->b)>1.0 ) { flag = 1; col->b = 1.0; }
if( flag ) nRecortesColor++;

return;
}

void scale_RGB(colorRGB *col)
{
LDBL max = 0.0;

max = dMAX3((col->r),(col->g),(col->b));
if( max>1.0 ) { nRecortesColor++; escalar_Por_Color(1.0/max,col); }

return;
}

void clip_RGB(colorRGB *col)
{
LDBL axis_rgb = 0.0, diff_mult = 1.0, tmp_mult = 0.0;

/********************************************************************
Utilizo color_COTA en lugar de diff (ver ref. bibliografica HALL, R.)
para no tener que definir otro colorRGB.
********************************************************************/

if( (col->r)>1.0 || (col->g)>1.0 || (col->b)>1.0 )
	{
	nRecortesColor++;
	axis_rgb = ((col->r)+(col->g)+(col->b))*(LDBL)(0.333333);
	if( axis_rgb<=(LDBL)(0.0001) )
		{
		(col->r) = (LDBL)(0.0);
		(col->g) = (LDBL)(0.0);
		(col->b) = (LDBL)(0.0);
		}
	else
		{
		if( axis_rgb>=(LDBL)(0.0001) )
			{
			(col->r) = (LDBL)(1.0);
			(col->g) = (LDBL)(1.0);
			(col->b) = (LDBL)(1.0);
			}
		else
			{
			(color_COTA->r) = (col->r)-axis_rgb;
			(color_COTA->g) = (col->g)-axis_rgb;
			(color_COTA->b) = (col->b)-axis_rgb;
			diff_mult = (LDBL)(1.0);
			if( (col->r)>(LDBL)(1.0) )
				{
				if((tmp_mult=((LDBL)(0.9999)-axis_rgb)/(color_COTA->r))<diff_mult)
					diff_mult = tmp_mult;
				}
			if( (col->g)>1.0 )
				{
				if((tmp_mult=((LDBL)(0.9999)-axis_rgb)/(color_COTA->g))<diff_mult)
					diff_mult = tmp_mult;
				}
			if( (col->b)>1.0 )
				{
				if((tmp_mult=((LDBL)(0.9999)-axis_rgb)/(color_COTA->b))<diff_mult)
					diff_mult = tmp_mult;
				}
			(col->r) = axis_rgb + diff_mult*(color_COTA->r);
			(col->g) = axis_rgb + diff_mult*(color_COTA->g);
			(col->b) = axis_rgb + diff_mult*(color_COTA->b);
			}
		}
	}

return;
}

void cota_RGB(colorRGB *col)
{
(col->r) /= (color_COTA->r);
(col->g) /= (color_COTA->g);
(col->b) /= (color_COTA->b);
scale_RGB(col);

return;
}

void suma_Color(colorRGB *col0, colorRGB *col1)
{
(col1->r) += (col0->r);
(col1->g) += (col0->g);
(col1->b) += (col0->b);

return;
}

void producto_Color(vector3D *v, colorRGB *c)
{
(c->r) *= (v->x);
(c->g) *= (v->y);
(c->b) *= (v->z);

return;
}

void escalar_Por_Color(LDBL k, colorRGB *c)
{
(c->r) *= k;
(c->g) *= k;
(c->b) *= k;

return;
}

void copia_Color(colorRGB *col0, colorRGB *col1)
{
*col1 = *col0;

return;
}

LDBL f_att(light *l, LDBL d)	/* Factor de atenuacin del foco */
{
LDBL temp = 0.0;

temp = (l->c0)+((l->c1)+(l->c2)*d)*d;
if( temp<CERO ) return( (LDBL)(1.0) );

return( dMIN2((LDBL)(1.0),(LDBL)(1.0)/temp) );
}

LDBL d_att(LDBL d)		/* Factor de atenuacion del rayo */
{
LDBL temp = 0.0;

temp = c0+(c1+c2*d)*d;
if( temp<CERO ) return( (LDBL)(1.0) );

return( dMIN2((LDBL)(1.0),(LDBL)(1.0)/temp) );
}

void actualiza_Cota_Color(colorRGB *color)
{
if( (color->r)>(color_MAXIMO->r) ) (color_MAXIMO->r) = (color->r);
if( (color->g)>(color_MAXIMO->g) ) (color_MAXIMO->g) = (color->g);
if( (color->b)>(color_MAXIMO->b) ) (color_MAXIMO->b) = (color->b);

return;
}