#include "svga.h"

LDBL normaVector( vector3D * );
void escalarPorVector( LDBL, vector3D *, vector3D * );
void vectorUnitario( vector3D *, vector3D * );
LDBL vecDot( vector3D *, vector3D * );
LDBL vecDot4x4( vector3D *, vector3D * );
void vecCross( vector3D *, vector3D *, vector3D * );
void restaVector( vector3D *, vector3D *, vector3D * );
void creaVector( vector3D *, vector3D *, vector3D * );
void creaVectorNoUnitario( vector3D *, vector3D *, vector3D * );
void copiaVector( vector3D *, vector3D * );
void normalCuadrica( matriz4x4 *, vector3D *, vector3D * );
void intersec_Cuadrica_y_Rayo_Primario( matriz4x4 *, rayo * );
void intersec_Cuadrica_y_Rayo_Secundario( matriz4x4 *, rayo * );
int  calculaInterseccion( rayo * );
void calcula_Cuadrica_Esfera( vector3D *, LDBL, matriz4x4 * );

void XYZ_a_Vector3D( LDBL, LDBL, LDBL, vector3D * );
void RGB_a_ColorRGB( LDBL, LDBL, LDBL, colorRGB * );
void cart_a_esf( vector3D *, vector3DEsf * );
void esf_a_cart(vector3DEsf *, vector3D * );
void calculoCoefMatrCambioBase( void );
void matrizPorPunto( matriz4x4 *, vector3D *, vector3D * );
void coordUniv_a_coordOjo( vector3D *, vector3D * );
void ptoTele_a_ptoPProy(int ,int ,vector3D *);
void matriz_Por_vector(matriz4x4 *, vector3D *, vector3D *);
void calculo_VolVis( void );
LDBL jitter_x( void );
LDBL jitter_y( void );
void traspuesta( matriz4x4 *, matriz4x4 * );
void matriz_x_matriz( matriz4x4 *, matriz4x4 *, matriz4x4 * );
void cambioBaseCuadrica( matriz4x4 *, matriz4x4 * );
void crea_Matriz_Inversa_Traslacion( LDBL, LDBL, LDBL, matriz4x4 * );
void crea_Matriz_Inversa_Escalado( LDBL, LDBL, LDBL, matriz4x4 * );
void crea_Matriz_Inversa_Rotacion( LDBL, LDBL, LDBL, matriz4x4 * );
void transformacion_De_Cuadrica( matriz4x4 *, matriz4x4 * );

int  recorrer_Pantalla_Con_Teclado( char * );
int  recorrer_Pantalla_Sin_Teclado( char * );
void rectangulo( int, int, int, int, unsigned long int );
void ya_He_Acabado( void );
void alocatar_Memoria( void );
int  Write(void *, unsigned );
int  WriteByte( Byte );
int  WriteWord( Word );
int  WriteZeros( int );
int  WriteFileHeader( void );
int  WriteFileFooter( void );
void TGA_SetImageID( char * );
void TGA_SetAuthor( char * );
void TGA_SetSoftwareID( char * );
void TGA_SetAspect( int, int );


void suma_Color( colorRGB *, colorRGB * );
void producto_Color( vector3D *, colorRGB * );
void escalar_Por_Color( LDBL, colorRGB * );
void normaliza_Color( colorRGB * );
void clamp_RGB( colorRGB * );
void scale_RGB( colorRGB * );
void clip_RGB( colorRGB * );
void cota_RGB( colorRGB * );
void copia_Color( colorRGB *, colorRGB * );
void actualiza_Cota_Color( colorRGB * );
LDBL f_att( light *, LDBL );
LDBL d_att( LDBL );

void traza_Rayo( rayo *, int );
void sombra_Rayo( rayo *, int );

vector3D      *alocata_Vector( void );
vector2D      *alocata_Vector2D( void );
colorRGB      *alocata_Color( void );
matriz4x4     *alocata_Matriz( void );
vector3DEsf   *alocata_Vector3DEsf( void );
rayo          *alocata_Rayo( void );
object        *alocata_Object( void );
interseccion  *alocata_Interseccion( void );
volumenVision *alocata_VolumenVision( void );
light	        *alocata_Light( void );
listaLights   *alocata_ListaLights( void );
listaObjects  *alocata_ListaObjects( void );
void	        alocata_Memoria( void );

void  estadisticas( void );
void  select_Graph_Mode( void );

void   lee_Datos( char * );
void   mensaje( unsigned );
UCHAR  lee_llaves( void );
void   lee_Foco( long );
light	 *crea_foco( long, vector3D *, vector3D *, vector3D *);
void 	 lee_Esfera( long );
object *crea_Esfera( long, vector3D *, LDBL, colorRGB *, colorRGB *,
							LDBL, LDBL, LDBL, vector3D *, LDBL, vector3D *,
							LDBL );
void 	 lee_Plano( long );
object *crea_Plano( long, vector3D *, vector3D *, colorRGB *, colorRGB *,
						  LDBL, LDBL, LDBL, vector3D *, LDBL, vector3D *,
						  LDBL );
void 	 lee_Cuadrica( long );
void 	 lee_Elipsoide( long );
object *crea_Cuadrica( long, matriz4x4 *, colorRGB *, colorRGB *, LDBL,
							  LDBL, LDBL, vector3D *, LDBL, vector3D *,
							  LDBL);