#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <stdio.h>
#include <alloc.h>
#include <math.h>
#include "rt_def.h"
#include "rt_func.h"
#include "rt_exter.h"

#define FIN_DE_SECCION -1

FILE *fp;

void lee_Datos(char *nombre)
{
int           tipo;
register long i = 0;
char          *encabezamiento = "Fichero de datos de RAY13\n",
				  *configuracion  = "Configuracion\n",
				  *volumenvision  = "Volumen de vision\n",
				  *ambiente       = "Condiciones ambientales\n",
				  *objetos = "Objetos\n", *focos = "Focos\n",
				  *esfera = "Esfera", *plano = "Plano",
				  *cuadrica = "Cuadrica", *elipsoide = "Elipsoide",
				  *clamp = "CLAMP", *scale = "SCALE",
				  *clip = "CLIP", *cota = "COTA",
				  *Yeah = "SI", *Nop = "NO", *fin = "}", c[70];
LDBL          alfa, beta, gamma;


// Apertura del fichero para la lectura de datos

if( (fp = fopen(nombre,"r")) == NULL )
	{
	clrscr();
	printf("\nError: No se pudo abrir el fichero %s\n", nombre);
	getch();
	exit(1);
	}

// El mensaje de encabezamiento es el 0

fgets(c, strlen(encabezamiento)+1, fp);
if( strcmp(c, encabezamiento)!=0 ) mensaje(0);
fgets(c, strlen("\n")+1, fp);           // Retorno de carro

// Los mensajes de configuracion son 1..99

fgets(c, strlen(configuracion)+1, fp);
if( strcmp(c, configuracion)!=0 ) mensaje(1);
if( lee_llaves()!=0 ) mensaje(2);
fscanf(fp, "Modo grafico (XRes,YRes,BitsPorPixel) = (%d,%d,%d)\n",
		&xMaxima,&yMaxima,&bitsPorPixel);
fscanf(fp, "Tamao de la imagen = %d x %d\n",&xRes,&yRes);
fscanf(fp, "Nivel de recursividad = %d\n",&max_Recursividad);
fscanf(fp, "Recorte de color = %s\n", c);
	if( strcmp(c, clamp)==0 ) recorteColor = CLAMP;
	else if( strcmp(c, scale)==0 ) recorteColor = SCALE;
		  else if( strcmp(c, clip)==0 ) recorteColor = CLIP;
				 else if( strcmp(c, cota)==0 ) recorteColor = COTA;
						else mensaje(3);
fscanf(fp, "Cota de color = (%lg,%lg,%lg)\n",&alfa,&beta,&gamma);
if( alfa==0.0 || beta==0.0 || gamma==0.0 ) mensaje(4);
RGB_a_ColorRGB(alfa,beta,gamma,color_COTA);
fscanf(fp, "Color ambiental = %s\n",c);
	if( strcmp(c, Yeah)==0 ) c_ambiental = Si;
	else if( strcmp(c, Nop)==0 ) c_ambiental = No;
		  else mensaje(5);
fscanf(fp, "Color aportado por las luces = %s\n",c);
	if( strcmp(c, Yeah)==0 ) c_luces = Si;
	else if( strcmp(c, Nop)==0 ) c_luces = No;
		  else mensaje(6);
fscanf(fp, "Sombras = %s\n",c);
	if( strcmp(c, Yeah)==0 ) sombras = Si;
	else if( strcmp(c, Nop)==0 ) sombras = No;
		  else mensaje(7);
fscanf(fp, "Reflexiones = %s\n",c);
	if( strcmp(c, Yeah)==0 ) reflexiones = Si;
	else if( strcmp(c, Nop)==0 ) reflexiones = No;
		  else mensaje(8);
fscanf(fp, "Refracciones = %s\n",c);
	if( strcmp(c, Yeah)==0 ) refracciones = Si;
	else if( strcmp(c, Nop)==0 ) refracciones = No;
		  else mensaje(9);
fscanf(fp, "Jittering = %s\n",c);
	if( strcmp(c, Yeah)==0 ) jitter = Si;
	else if( strcmp(c, Nop)==0 ) jitter = No;
		  else mensaje(10);
fscanf(fp, "Estadisticas = %s\n",c);
	if( strcmp(c, Yeah)==0 ) stats = Si;
	else if( strcmp(c, Nop)==0 ) stats = No;
		  else mensaje(11);
fscanf(fp, "Leer teclado = %s\n",c);
	if( strcmp(c, Yeah)==0 ) leerTeclado = Si;
	else if( strcmp(c, Nop)==0 ) leerTeclado = No;
		  else mensaje(12);
if( lee_llaves()!=1 ) mensaje(99);

// Los mensajes de volumen de vision son 100..199

fgets(c, strlen(volumenvision)+1, fp);
if( strcmp(c, volumenvision)!=0 ) mensaje(100);
if( lee_llaves()!=0 ) mensaje(101);
fscanf(fp, "Ojo = (%lg,%lg,%lg)\n",&alfa,&beta,&gamma);
XYZ_a_Vector3D(alfa,beta,gamma,volVis->ojo);
fscanf(fp, "Angulo de vision = %lg\n",&alfa);
volVis->angVisHorizontal   = alfa*pi/(LDBL)(180.0);
if(xRes==yRes)	volVis->angVisVertical = volVis->angVisHorizontal;
else 				volVis->angVisVertical = (LDBL)(2.0) *
													 atan(((LDBL)yRes/(LDBL)xRes) *
													 tan((volVis->angVisHorizontal) /
													 (LDBL)(2.0)));

cart_a_esf((volVis->ojo),ojoEsf);
calculoCoefMatrCambioBase();
calculo_VolVis();
if( lee_llaves()!=1 ) mensaje(199);

// Los mensajes de ambiente son 200..299

fgets(c, strlen(ambiente)+1, fp);
if( strcmp(c, ambiente)!=0 ) mensaje(200);
if( lee_llaves()!=0 ) mensaje(201);
fscanf(fp, "Color de fondo = (%lg,%lg,%lg)\n",&alfa,&beta,&gamma);
RGB_a_ColorRGB(alfa,beta,gamma,color_Fondo);
fscanf(fp, "Luz ambiental = (%lg,%lg,%lg)\n",&alfa,&beta,&gamma);
XYZ_a_Vector3D(alfa,beta,gamma,luz_Ambiental);
fscanf(fp, "Atenuacion = (%lg,%lg,%lg)\n",&alfa,&beta,&gamma);
c0 = alfa;
c1 = beta;
c2 = gamma;
if( lee_llaves()!=1 ) mensaje(299);

// Los mensajes de lista de objetos son 300..399

fgets(c, strlen(objetos)+1, fp);
if( strcmp(c, objetos)!=0 ) mensaje(300);
if( lee_llaves()!=0 ) mensaje(301);

listaObjetos = alocata_ListaObjects();

do
	{
	fscanf(fp,"%s\n",c);
	if( strcmp(c, esfera)==0 ) { tipo = ESFERA; i++; }
	else if( strcmp(c, plano)==0 ) { tipo = PLANO; i++; }
	else if( strcmp(c, cuadrica)==0 ) { tipo = CUADRICA; i++; }
	else if( strcmp(c, elipsoide)==0 ) { tipo = ELIPSOIDE; i++; }
	else if( strcmp(c, fin)==0 ) tipo = FIN_DE_SECCION;
	else tipo = INDEFINIDO;

	switch( tipo )
		{
		case INDEFINIDO:
			{
			mensaje(302);
			}
		case ESFERA:
			{

			// Los mensajes de esfera son 600..699

			if( lee_llaves()!=0 ) mensaje(600);
			lee_Esfera(i);
			if( lee_llaves()!=1 ) mensaje(699);
			break;
			}
		case PLANO:
			{

			// Los mensajes de plano son 700..799

			if( lee_llaves()!=0 ) mensaje(700);
			lee_Plano(i);
			if( lee_llaves()!=1 ) mensaje(799);
			break;
			}
		case CUADRICA:
			{

			// Los mensajes de cuadrica son 800..899

			if( lee_llaves()!=0 ) mensaje(800);
			lee_Cuadrica(i);
			if( lee_llaves()!=1 ) mensaje(899);
			break;
			}
		case ELIPSOIDE:
			{

			// Los mensajes de elipsoide son 900..999

			if( lee_llaves()!=0 ) mensaje(900);
			lee_Elipsoide(i);
			if( lee_llaves()!=1 ) mensaje(999);
			break;
			}
		}
	}
while( tipo != FIN_DE_SECCION );
i = 0;

// Los mensajes de lista de focos son 400..499

fgets(c, strlen(focos)+1, fp);
if( strcmp(c, focos)!=0 ) mensaje(400);
if( lee_llaves()!=0 ) mensaje(401);

listaFocos = alocata_ListaLights();

tipo = PLANO;	// El que sea PLANO es indiferente. Lo que importa es que NO
					//	sea FIN_DE_SECCION

do
	{
	fscanf(fp,"%s\n",c);
	if( strcmp(c, fin)==0 ) tipo = FIN_DE_SECCION;
	else
		{
		i++;

		// Los mensajes de foco son 500..599

		lee_Foco(i);
		if( lee_llaves()!=1 ) mensaje(599);
		}
	}
while( tipo != FIN_DE_SECCION );

fclose(fp);
}

void mensaje(unsigned i)
{
clrscr();
printf("\nError: Formato incorrecto (%u)\n",i);
getch();
exit(1);

return;
}

UCHAR lee_llaves(void)
{
char *inicio = "{",
	  *fin = "}",
		c[70];

fgets(c, strlen(inicio)+1, fp);
if( strcmp(c, inicio)==0 )
	{
	fgets(c, 3, fp);
	return(0);
	}
if( strcmp(c, fin)==0 )
	{
	fgets(c, 3, fp);
	return(1);
	}

return(2);
}

void lee_Foco( long n )
{
vector3D *o, *i, *a;
LDBL      x, y, z;
char      cc[70];

o = alocata_Vector();
i = alocata_Vector();
a = alocata_Vector();

fgets(cc, 70, fp);

fscanf(fp, "origen = (%lg,%lg,%lg)\n", &x, &y, &z);
XYZ_a_Vector3D(x,y,z,o);
coordUniv_a_coordOjo(o, o);
fscanf(fp, "intensidad = (%lg,%lg,%lg)\n", &x, &y, &z);
XYZ_a_Vector3D(x,y,z,i);
fscanf(fp, "atenuacion = (%lg,%lg,%lg)\n", &x, &y, &z);
XYZ_a_Vector3D(x,y,z,a);

crea_foco(n,o,i,a);


return;
}

light* crea_foco( long n, vector3D *o, vector3D *i, vector3D *a)
{
light *pl;


pl = alocata_Light();

++(listaFocos->nFocos);
if( (listaFocos->focoFinal)==NULL )
	{
	(listaFocos->focoInicial) = (listaFocos->focoFinal) = pl;
	(listaFocos->focoInicial->focoPrevio) = NULL;
	}
else
	{
	(pl->focoPrevio) = (listaFocos->focoFinal);
	(listaFocos->focoFinal) =
	(listaFocos->focoFinal->focoSiguiente) = pl;
	}
(pl->focoSiguiente) = NULL;
(pl->posicion) = n;
copiaVector(o,(pl->origen));
copiaVector(i,(pl->intensidad));
(pl->c0) = (a->x);
(pl->c1) = (a->y);
(pl->c2) = (a->z);

return(pl);
}

void lee_Esfera( long n )
{
vector3D *centroEsfera, *ks, *kt;
colorRGB *cd, *ce;
LDBL      x, y, z, r, ka, kd, kh, nexp, ir;
char      cc[70];


centroEsfera = alocata_Vector();
ks           = alocata_Vector();
kt           = alocata_Vector();
cd           = alocata_Color();
ce           = alocata_Color();

fgets(cc, 70, fp);

fscanf(fp, "centro = (%lg,%lg,%lg)\n", &x, &y, &z);
XYZ_a_Vector3D(x,y,z,centroEsfera);

coordUniv_a_coordOjo(centroEsfera, centroEsfera);

fscanf(fp, "radio = %lg\n",&r);
if( r<=0.0 ) mensaje(601);

fscanf(fp, "color difuso = (%lg,%lg,%lg)\n", &x, &y, &z);
RGB_a_ColorRGB(x,y,z,cd);
fscanf(fp, "color especular = (%lg,%lg,%lg)\n", &x, &y, &z);
RGB_a_ColorRGB(x,y,z,ce);
fscanf(fp, "Ka = %lg\n",&ka);
fscanf(fp, "Kd = %lg\n",&kd);
fscanf(fp, "Kh = %lg\n",&kh);
fscanf(fp, "Ks = (%lg,%lg,%lg)\n", &x, &y, &z);
XYZ_a_Vector3D(x,y,z,ks);
fscanf(fp, "n = %lg\n",&nexp);
fscanf(fp, "Kt = (%lg,%lg,%lg)\n", &x, &y, &z);
XYZ_a_Vector3D(x,y,z,kt);
fscanf(fp, "iR = %lg\n",&ir);

crea_Esfera(n, centroEsfera, r, cd, ce, ka, kd, kh, ks, nexp, kt, ir);

free(centroEsfera);
free(ks);
free(kt);
free(cd);
free(ce);


return;
}

object *crea_Esfera(long n, vector3D *centroEsfera, LDBL r,
						  colorRGB *cd, colorRGB *ce,
						  LDBL ka, LDBL kd, LDBL kh,
						  vector3D *ks, LDBL nexp, vector3D *kt, LDBL ir)
{
object *po;


po = alocata_Object();

++(listaObjetos->nObjetos);
if( (listaObjetos->objetoFinal)==NULL )
	{
	(listaObjetos->objetoInicial) = (listaObjetos->objetoFinal) = po;
	(listaObjetos->objetoInicial->objetoPrevio) = NULL;
	}
else
	{
	(po->objetoPrevio) = (listaObjetos->objetoFinal);
	(listaObjetos->objetoFinal) =
	(listaObjetos->objetoFinal->objetoSiguiente) =  po;
	}
(po->objetoSiguiente) = NULL;
(po->posicion) = n;

calcula_Cuadrica_Esfera(centroEsfera,r,(po->ecuacion));
(po->ecuacion->tipo) = ESFERA;

copia_Color(cd,(po->color_difuso));
copia_Color(ce,(po->color_especular));
(po->Ka) = ka;
(po->Kd) = kd;
(po->Kh) = kh;
copiaVector(ks,(po->Ks));
(po->n) = nexp;
copiaVector(kt,(po->Kt));
(po->iR) = ir;


return(po);
}

void lee_Plano( long n )
{
vector3D *p0, *p1, *p2, *v01, *v02, *normal, *ks, *kt;
colorRGB *cd, *ce;
LDBL      x, y, z, ka, kd, kh, nexp, ir;
char      cc[70];

p0     = alocata_Vector();
p1     = alocata_Vector();
p2     = alocata_Vector();
v01    = alocata_Vector();
v02    = alocata_Vector();
normal = alocata_Vector();
ks     = alocata_Vector();
kt     = alocata_Vector();
cd     = alocata_Color();
ce     = alocata_Color();

fgets(cc, 70, fp);

fscanf(fp, "p0 = (%lg,%lg,%lg)\n", &x, &y, &z);
XYZ_a_Vector3D(x,y,z,p0);
coordUniv_a_coordOjo(p0, p0);
fscanf(fp, "p1 = (%lg,%lg,%lg)\n", &x, &y, &z);
XYZ_a_Vector3D(x,y,z,p1);
coordUniv_a_coordOjo(p1, p1);
fscanf(fp, "p2 = (%lg,%lg,%lg)\n", &x, &y, &z);
XYZ_a_Vector3D(x,y,z,p2);
coordUniv_a_coordOjo(p2, p2);
creaVector(p0,p1,v01);
creaVector(p0,p2,v02);
vecCross(v01,v02,normal);
vectorUnitario(normal,normal);
/*
// Ahora comprobare si la normal 'apunta' hacia el ojo
if( vecDot(p0,normal)>(LDBL)(0.0) )
	{
	escalarPorVector(-1.0,normal,normal); // No lo esta -> Le doy la vuelta
	}
*/
fscanf(fp, "color difuso = (%lg,%lg,%lg)\n", &x, &y, &z);
RGB_a_ColorRGB(x,y,z,cd);
fscanf(fp, "color especular = (%lg,%lg,%lg)\n", &x, &y, &z);
RGB_a_ColorRGB(x,y,z,ce);
fscanf(fp, "Ka = %lg\n",&ka);
fscanf(fp, "Kd = %lg\n",&kd);
fscanf(fp, "Kh = %lg\n",&kh);
fscanf(fp, "Ks = (%lg,%lg,%lg)\n", &x, &y, &z);
XYZ_a_Vector3D(x,y,z,ks);
fscanf(fp, "n = %lg\n",&nexp);
fscanf(fp, "Kt = (%lg,%lg,%lg)\n", &x, &y, &z);
XYZ_a_Vector3D(x,y,z,kt);
fscanf(fp, "iR = %lg\n",&ir);

crea_Plano(n, normal, p0, cd, ce, ka, kd, kh, ks, nexp, kt, ir);

free(p0);
free(p1);
free(p2);
free(v01);
free(v02);
free(normal);
free(ks);
free(kt);
free(cd);
free(ce);


return;
}

object* crea_Plano(long n, vector3D *normalPlano, vector3D *pto,
						 colorRGB *cd, colorRGB *ce,
						 LDBL ka, LDBL kd, LDBL kh,
						 vector3D *ks, LDBL nexp, vector3D *kt, LDBL ir)
{
object *po;


po = alocata_Object();

++(listaObjetos->nObjetos);
if( (listaObjetos->objetoFinal)==NULL )
	{
	(listaObjetos->objetoInicial) = (listaObjetos->objetoFinal) = po;
	(listaObjetos->objetoInicial->objetoPrevio) = NULL;
	}
else
	{
	(po->objetoPrevio) = (listaObjetos->objetoFinal);
	(listaObjetos->objetoFinal) =
	(listaObjetos->objetoFinal->objetoSiguiente) =  po;
	}
(po->objetoSiguiente) = NULL;

(po->posicion) = n;

(po->ecuacion->tipo) = PLANO;

(po->ecuacion->f1->t) = (normalPlano->x) / (LDBL)(2.0);
(po->ecuacion->f2->t) = (normalPlano->y) / (LDBL)(2.0);
(po->ecuacion->f3->t) = (normalPlano->z) / (LDBL)(2.0);
(po->ecuacion->f4->x) = (normalPlano->x) / (LDBL)(2.0);
(po->ecuacion->f4->y) = (normalPlano->y) / (LDBL)(2.0);
(po->ecuacion->f4->z) = (normalPlano->z) / (LDBL)(2.0);
(po->ecuacion->f4->t) = -( (normalPlano->x)*(pto->x) +
									(normalPlano->y)*(pto->y) +
									(normalPlano->z)*(pto->z) );

copia_Color(cd,(po->color_difuso));
copia_Color(ce,(po->color_especular));
(po->Ka) = ka;
(po->Kd) = kd;
(po->Kh) = kh;
copiaVector(ks,(po->Ks));
(po->n) = nexp;
copiaVector(kt,(po->Kt));
(po->iR) = ir;


return(po);
}

void lee_Cuadrica( long n )
{
colorRGB  *cd, *ce;
matriz4x4 *Q, *TRASLACION_Inv, *ESCALADO_Inv, *ROTACION_Inv;
vector3D  *ks, *kt;
LDBL       A, B, C, D, E, F, G, H, I, J, x, y, z, ka, kd, kh, nexp, ir;
char       cc[70];


Q              = alocata_Matriz();
TRASLACION_Inv = alocata_Matriz();
ESCALADO_Inv   = alocata_Matriz();
ROTACION_Inv   = alocata_Matriz();
ks             = alocata_Vector();
kt             = alocata_Vector();
cd             = alocata_Color();
ce             = alocata_Color();

fgets(cc, 70, fp);

fscanf(fp,"{ A x^2 + B y^2 + C z^2 + D xy + E xz + F yz + G x + H y + I z + J = 0 }\n");
fscanf(fp, "A = %lg\n",&A);
fscanf(fp, "B = %lg\n",&B);
fscanf(fp, "C = %lg\n",&C);
fscanf(fp, "D = %lg\n",&D);
fscanf(fp, "E = %lg\n",&E);
fscanf(fp, "F = %lg\n",&F);
fscanf(fp, "G = %lg\n",&G);
fscanf(fp, "H = %lg\n",&H);
fscanf(fp, "I = %lg\n",&I);
fscanf(fp, "J = %lg\n",&J);
(Q->f1->x) = A;
(Q->f1->y) = D / 2.0;
(Q->f1->z) = E / 2.0;
(Q->f1->t) = G / 2.0;
(Q->f2->x) = D / 2.0;
(Q->f2->y) = B;
(Q->f2->z) = F / 2.0;
(Q->f2->t) = H / 2.0;
(Q->f3->x) = E / 2.0;
(Q->f3->y) = F / 2.0;
(Q->f3->z) = C;
(Q->f3->t) = I / 2.0;
(Q->f4->x) = G / 2.0;
(Q->f4->y) = H / 2.0;
(Q->f4->z) = I / 2.0;
(Q->f4->t) = J;

fscanf(fp, "Traslacion = (%lg,%lg,%lg)\n", &x, &y, &z);
crea_Matriz_Inversa_Traslacion(x,y,z,TRASLACION_Inv);
transformacion_De_Cuadrica(TRASLACION_Inv,Q);

fscanf(fp, "Escalado = (%lg,%lg,%lg)\n", &x, &y, &z);
crea_Matriz_Inversa_Escalado(x,y,z,ESCALADO_Inv);
transformacion_De_Cuadrica(ESCALADO_Inv,Q);

fscanf(fp, "Rotacion = (%lg,%lg,%lg)\n", &x, &y, &z);
crea_Matriz_Inversa_Rotacion(x,y,z,ROTACION_Inv);
transformacion_De_Cuadrica(ROTACION_Inv,Q);

cambioBaseCuadrica(Q,Q);

fscanf(fp, "color difuso = (%lg,%lg,%lg)\n", &x, &y, &z);
RGB_a_ColorRGB(x,y,z,cd);
fscanf(fp, "color especular = (%lg,%lg,%lg)\n", &x, &y, &z);
RGB_a_ColorRGB(x,y,z,ce);
fscanf(fp, "Ka = %lg\n",&ka);
fscanf(fp, "Kd = %lg\n",&kd);
fscanf(fp, "Kh = %lg\n",&kh);
fscanf(fp, "Ks = (%lg,%lg,%lg)\n", &x, &y, &z);
XYZ_a_Vector3D(x,y,z,ks);
fscanf(fp, "n = %lg\n",&nexp);
fscanf(fp, "Kt = (%lg,%lg,%lg)\n", &x, &y, &z);
XYZ_a_Vector3D(x,y,z,kt);
fscanf(fp, "iR = %lg\n",&ir);

crea_Cuadrica(n, Q, cd, ce, ka, kd, kh, ks, nexp, kt, ir);

free(Q);
free(ks);
free(kt);
free(cd);
free(ce);
free(TRASLACION_Inv);
free(ESCALADO_Inv);
free(ROTACION_Inv);


return;
}

void lee_Elipsoide( long n )
{
vector3D  *ks, *kt;
colorRGB  *cd, *ce;
matriz4x4 *Q, *TRASLACION_Inv, *ESCALADO_Inv, *ROTACION_Inv;
LDBL       x, y, z, a, b, c, ka, kd, kh, nexp, ir;
char       cc[70];

Q              = alocata_Matriz();
TRASLACION_Inv = alocata_Matriz();
ESCALADO_Inv   = alocata_Matriz();
ROTACION_Inv   = alocata_Matriz();
ks             = alocata_Vector();
kt             = alocata_Vector();
cd             = alocata_Color();
ce             = alocata_Color();

fgets(cc, 70, fp);

fscanf(fp, "centro = (%lg,%lg,%lg)\n", &x, &y, &z);

fscanf(fp, "semiejes = (%lg,%lg,%lg)\n", &a, &b, &c);
if( a == 0.0 || b == 0.0 || c == 0.0 ) mensaje(901);

// Expresamos los datos en forma de cuadrica
a = a*a;
b = b*b;
c = c*c;
(Q->f1->x) = (LDBL)1.0 / a;
(Q->f1->y) = (LDBL)0.0;
(Q->f1->z) = (LDBL)0.0;
(Q->f1->t) = -( x / a );
(Q->f2->x) = (LDBL)0.0;
(Q->f2->y) = (LDBL)1.0 / b;
(Q->f2->z) = (LDBL)0.0;
(Q->f2->t) = -( y / b );
(Q->f3->x) = (LDBL)0.0;
(Q->f3->y) = (LDBL)0.0;
(Q->f3->z) = (LDBL)1.0 / c;
(Q->f3->t) = -( z / c );
(Q->f4->x) = -( x / a );
(Q->f4->y) = -( y / b );
(Q->f4->z) = -( z / c );
(Q->f4->t) =  (x*x)/a + (y*y)/b + (z*z)/c - (LDBL)1.0;

fscanf(fp, "Traslacion = (%lg,%lg,%lg)\n", &x, &y, &z);
crea_Matriz_Inversa_Traslacion(x,y,z,TRASLACION_Inv);
transformacion_De_Cuadrica(TRASLACION_Inv,Q);

fscanf(fp, "Escalado = (%lg,%lg,%lg)\n", &x, &y, &z);
crea_Matriz_Inversa_Escalado(x,y,z,ESCALADO_Inv);
transformacion_De_Cuadrica(ESCALADO_Inv,Q);

fscanf(fp, "Rotacion = (%lg,%lg,%lg)\n", &x, &y, &z);
crea_Matriz_Inversa_Rotacion(x,y,z,ROTACION_Inv);
transformacion_De_Cuadrica(ROTACION_Inv,Q);

cambioBaseCuadrica(Q,Q);

fscanf(fp, "color difuso = (%lg,%lg,%lg)\n", &x, &y, &z);
RGB_a_ColorRGB(x,y,z,cd);
fscanf(fp, "color especular = (%lg,%lg,%lg)\n", &x, &y, &z);
RGB_a_ColorRGB(x,y,z,ce);
fscanf(fp, "Ka = %lg\n",&ka);
fscanf(fp, "Kd = %lg\n",&kd);
fscanf(fp, "Kh = %lg\n",&kh);
fscanf(fp, "Ks = (%lg,%lg,%lg)\n", &x, &y, &z);
XYZ_a_Vector3D(x,y,z,ks);
fscanf(fp, "n = %lg\n",&nexp);
fscanf(fp, "Kt = (%lg,%lg,%lg)\n", &x, &y, &z);
XYZ_a_Vector3D(x,y,z,kt);
fscanf(fp, "iR = %lg\n",&ir);

crea_Cuadrica(n, Q, cd, ce, ka, kd, kh, ks, nexp, kt, ir);

free(Q);
free(ks);
free(kt);
free(cd);
free(ce);
free(TRASLACION_Inv);
free(ESCALADO_Inv);
free(ROTACION_Inv);


return;
}

object* crea_Cuadrica(long n, matriz4x4 *Q, colorRGB *cd, colorRGB *ce,
			LDBL ka, LDBL kd, LDBL kh, vector3D *ks,
			LDBL nexp, vector3D *kt, LDBL ir)
{
object *po;


po = alocata_Object();

++(listaObjetos->nObjetos);
if( (listaObjetos->objetoFinal)==NULL )
	{
	(listaObjetos->objetoInicial) = (listaObjetos->objetoFinal) = po;
	(listaObjetos->objetoInicial->objetoPrevio) = NULL;
	}
else
	{
	(po->objetoPrevio) = (listaObjetos->objetoFinal);
	(listaObjetos->objetoFinal) =
	(listaObjetos->objetoFinal->objetoSiguiente) =  po;
	}
(po->objetoSiguiente) = NULL;

(po->posicion) = n;

*(po->ecuacion) = *Q;
(po->ecuacion->tipo) = CUADRICA;

copia_Color(cd,(po->color_difuso));
copia_Color(ce,(po->color_especular));
(po->Ka) = ka;
(po->Kd) = kd;
(po->Kh) = kh;
copiaVector(ks,(po->Ks));
(po->n) = nexp;
copiaVector(kt,(po->Kt));
(po->iR) = ir;


return(po);
}

void XYZ_a_Vector3D(LDBL x, LDBL y, LDBL z, vector3D *v)
{
v->x = x;
v->y = y;
v->z = z;
v->t = (LDBL)(1.0);

return;
}

void RGB_a_ColorRGB(LDBL r, LDBL g, LDBL b, colorRGB *c)
{
c->r = r;
c->g = g;
c->b = b;

return;
}