#include <stdlib.h>
#include <alloc.h>
#include <math.h>
#include "rt_def.h"
#include "rt_func.h"
#include "rt_exter.h"


void intersec_Cuadrica_y_Rayo_Primario( matriz4x4 *Q, rayo *r)
{
LDBL a=0.0, b=0.0, c=0.0, DELTA=0.0, tt1 = 0.0, tt2 = 0.0;

tmin_tmax->x = 0.0;
tmin_tmax->y = 0.0;

b = (LDBL)(2.0)*( (Q->f1->t)*(r->dir->x) +
						(Q->f2->t)*(r->dir->y) +
						(Q->f3->t)*(r->dir->z) );

c = (Q->f4->t);

if( (Q->tipo) == PLANO )
	{
	if( dABS(b)<CERO ) return;
	else
		{
		tmin_tmax->x = -c/b;
		tmin_tmax->y =  INFINITO;
		return;
		}
	}

if( (Q->tipo) == ESFERA )
	{
	a = (r->dir->x)*(Q->f1->x)*(r->dir->x) +
		 (r->dir->y)*(Q->f2->y)*(r->dir->y) +
		 (r->dir->z)*(Q->f3->z)*(r->dir->z);
	}

if( (Q->tipo) == CUADRICA )
	{
	a = (r->dir->x)*( (Q->f1->x)*(r->dir->x) +
							(LDBL)(2.0)*( (Q->f1->y)*(r->dir->y) +
											  (Q->f1->z)*(r->dir->z) ) );
	a+= (r->dir->y)*( (Q->f2->y)*(r->dir->y) +
							(LDBL)(2.0)*(Q->f2->z)*(r->dir->z) );
	a+= (r->dir->z)*(	(Q->f3->z)*(r->dir->z) );
	}

DELTA = b*b - (LDBL)(4.0)*a*c;
if( DELTA<(LDBL)(0.0) )	return;
if( dABS(a)<CERO )
	{
	if( dABS(b)<CERO ) return;
	else
		{
		tmin_tmax->x = -c/b;
		tmin_tmax->y =  INFINITO;
		return;
		}
	}
else
	{
	tt1 = (sqrt(DELTA)-b)/((LDBL)(2.0)*a);
	tt2 = (b+sqrt(DELTA))/((LDBL)(-2.0)*a);
	tmin_tmax->x = dMIN2(tt1,tt2);
	tmin_tmax->y = dMAX2(tt1,tt2);
	return;
	}
}

void intersec_Cuadrica_y_Rayo_Secundario( matriz4x4 *Q, rayo *r)
{
LDBL a=0.0, b=0.0, c=0.0, DELTA=0.0, tt1=0.0, tt2=0.0, tmp = 0.0;

tmin_tmax->x = 0.0;
tmin_tmax->y = 0.0;

b = (Q->f1->x)*(r->origen->x)*(r->dir->x) +
	 (Q->f2->y)*(r->origen->y)*(r->dir->y) +
	 (Q->f3->z)*(r->origen->z)*(r->dir->z);
b+= (Q->f1->t)*(r->dir->x) +
	 (Q->f2->t)*(r->dir->y) +
	 (Q->f3->t)*(r->dir->z);
b*= (LDBL)(2.0);

c = (r->origen->x)*( (Q->f1->x)*(r->origen->x) +
							(LDBL)(2.0)*( (Q->f1->y)*(r->origen->y) +
											  (Q->f1->z)*(r->origen->z) +
											  (Q->f1->t) ) );
c+= (r->origen->y)*( (Q->f2->y)*(r->origen->y) +
							(LDBL)(2.0)*( (Q->f2->z)*(r->origen->z) +
											  (Q->f2->t) ) );
c+= (r->origen->z)*( (Q->f3->z)*(r->origen->z) +
							(LDBL)(2.0)*(Q->f3->t) ) + (Q->f4->t);

if( (Q->tipo) == PLANO )
	{
	c = (r->origen->x)*( (Q->f1->x)*(r->origen->x) +
								(LDBL)(2.0)*(Q->f1->t) );
	c+= (r->origen->y)*( (Q->f2->y)*(r->origen->y) +
								(LDBL)(2.0)*(Q->f2->t) );
	c+= (r->origen->z)*( (Q->f3->z)*(r->origen->z) +
								(LDBL)(2.0)*(Q->f3->t) ) + (Q->f4->t);

	if( dABS(b)<CERO ) return;
	else
		{
		tmin_tmax->x = -c/b;
		tmin_tmax->y =  INFINITO;
		return;
		}
	}

if( (Q->tipo) == ESFERA )
	{
	a = (r->dir->x)*(Q->f1->x)*(r->dir->x) +
		 (r->dir->y)*(Q->f2->y)*(r->dir->y) +
		 (r->dir->z)*(Q->f3->z)*(r->dir->z);

	c = (r->origen->x)*( (Q->f1->x)*(r->origen->x) +
								(LDBL)(2.0)*(Q->f1->t) );
	c+= (r->origen->y)*( (Q->f2->y)*(r->origen->y) +
								(LDBL)(2.0)*(Q->f2->t) );
	c+= (r->origen->z)*( (Q->f3->z)*(r->origen->z) +
								(LDBL)(2.0)*(Q->f3->t) ) +
								(Q->f4->t);
	}

if( (Q->tipo) == CUADRICA )
	{
	a = (r->dir->x)*( (Q->f1->x)*(r->dir->x) +
							(LDBL)(2.0)*( (Q->f1->y)*(r->dir->y) +
											  (Q->f1->z)*(r->dir->z)) );
	a+= (r->dir->y)*( (Q->f2->y)*(r->dir->y) +
							(LDBL)(2.0)*(Q->f2->z)*(r->dir->z) );
	a+= (r->dir->z)*(	(Q->f3->z)*(r->dir->z) );

	tmp=  (Q->f1->y)*( (r->origen->x)*(r->dir->y) +
							 (r->origen->y)*(r->dir->x) );
	tmp+= (Q->f1->z)*( (r->origen->x)*(r->dir->z) +
							 (r->origen->z)*(r->dir->x) );
	tmp+= (Q->f2->z)*( (r->origen->y)*(r->dir->z) +
							 (r->origen->z)*(r->dir->y) );
	tmp*=(LDBL)(2.0);
	b+=tmp;

	c = (r->origen->x)*( (Q->f1->x)*(r->origen->x) +
								(LDBL)(2.0)*( (Q->f1->y)*(r->origen->y) +
												  (Q->f1->z)*(r->origen->z) +
												  (Q->f1->t) ) );
	c+= (r->origen->y)*( (Q->f2->y)*(r->origen->y) +
								(LDBL)(2.0)*( (Q->f2->z)*(r->origen->z) +
												  (Q->f2->t) ) );
	c+= (r->origen->z)*( (Q->f3->z)*(r->origen->z) +
								(LDBL)(2.0)*(Q->f3->t) ) + (Q->f4->t);
	}

DELTA = b*b - (LDBL)(4.0)*a*c;
if( DELTA<(LDBL)(0.0) )	return;
if( dABS(a)<CERO )
	{
	if( dABS(b)<CERO ) return;
	else
		{
		tmin_tmax->x = -c/b;
		tmin_tmax->y =  INFINITO;
		return;
		}
	}
else
	{
	tt1 = (sqrt(DELTA)-b)/((LDBL)(2.0)*a);
	tt2 = (sqrt(DELTA)+b)/((LDBL)(-2.0)*a);
	tmin_tmax->x = dMIN2(tt1,tt2);
	tmin_tmax->y = dMAX2(tt1,tt2);
	return;
	}
}

int calculaInterseccion(rayo *r)
{
object *pObject;
LDBL   t = INFINITO, taux = 0.0;
int    flag = 0;

if( (r->tipo)==PRIMARIO )
  {
  for(pObject=listaObjetos->objetoInicial;
		pObject!=NULL;
		pObject=pObject->objetoSiguiente)
	  {
	  intersec_Cuadrica_y_Rayo_Primario((pObject->ecuacion),r);
	  if( tmin_tmax->x<CERO )
		{
		if( tmin_tmax->y<CERO )	taux = 0.0;
		else taux = tmin_tmax->y;
		}
	  else taux = tmin_tmax->x;
	  if( taux!=0.0 )
		 {
		 if( taux<t )
			{
			flag = 1;
			t    = taux;
			(intersec->pto->x) = taux*(r->dir->x);
			(intersec->pto->y) = taux*(r->dir->y);
			(intersec->pto->z) = taux*(r->dir->z);
			*intersec->objeto  = *pObject;
			}
		 }	// fin  if(taux!=0)
	  } // fin  for
  } // fin  if(tipoRayo=Primario)
else
  {
  for(pObject=listaObjetos->objetoInicial;
		pObject!=NULL;
		pObject=pObject->objetoSiguiente)
	  {
	  intersec_Cuadrica_y_Rayo_Secundario((pObject->ecuacion),r);
	  if( tmin_tmax->x<CERO )
		{
		if( tmin_tmax->y<CERO )	taux = 0.0;
		else taux = tmin_tmax->y;
		}
	  else taux = tmin_tmax->x;
	  if( taux!=0.0 )
		 {
		 if( taux<t )
			{
			flag = 1;
			t    = taux;
			(intersec->pto->x) = (r->origen->x) + taux*(r->dir->x);
			(intersec->pto->y) = (r->origen->y) + taux*(r->dir->y);
			(intersec->pto->z) = (r->origen->z) + taux*(r->dir->z);
			*intersec->objeto  = *pObject;
			}
		 }	// fin  if(taux!=0)
	  }	// fin  for
  }
if( flag )
	{
	(r->d) += t;
	switch( (r->tipo) )
		{
		case PRIMARIO:   { nPrimariosHit++; break; }
		case REFLEJADO:  { nReflejadosHit++; break; }
		case REFRACTADO: { nRefractadosHit++; break;	}
		}
	}

return( flag );
}

void normalCuadrica( matriz4x4 *c, vector3D *p, vector3D *normal)
{
if( (c->tipo) == PLANO )
	{
	XYZ_a_Vector3D( (c->f1->t), (c->f2->t), (c->f3->t), normal);
	}
else
	{
	XYZ_a_Vector3D( (c->f1->x)*(p->x) + (c->f1->y)*(p->y) +
						 (c->f1->z)*(p->z) + (c->f1->t),
						 (c->f2->y)*(p->y) + (c->f1->y)*(p->x) +
						 (c->f2->z)*(p->z) + (c->f2->t),
						 (c->f3->z)*(p->z) + (c->f1->z)*(p->x) +
						 (c->f2->z)*(p->y) + (c->f3->t),
						 normal);
	vectorUnitario(normal,normal);
	}
normal->t = (LDBL)1.0;

return;
}

void calcula_Cuadrica_Esfera( vector3D *centro, LDBL radio, matriz4x4 *eq )
{
eq->f1->x = 1.0;
eq->f2->y = 1.0;
eq->f3->z = 1.0;
eq->f1->y = 0.0;
eq->f2->z = 0.0;
eq->f1->z = 0.0;
eq->f3->x = 0.0;
eq->f2->z = 0.0;
eq->f3->y = 0.0;
eq->f1->t = -(centro->x);
eq->f4->x = -(centro->x);
eq->f2->t = -(centro->y);
eq->f4->y = -(centro->y);
eq->f3->t = -(centro->z);
eq->f4->y = -(centro->z);
eq->f4->t = (centro->x)*(centro->x)+(centro->y)*(centro->y) +
						  (centro->z)*(centro->z)-(radio*radio);

return;
}

/*********************************************
		  FUNCIONES MATEMATICAS
*********************************************/

void cart_a_esf( vector3D *pC, vector3DEsf *pE )
{
register LDBL temp=(LDBL)(0.0);

(pE->r) = sqrt( (pC->x)*(pC->x) + (pC->y)*(pC->y) + (pC->z)*(pC->z) );

temp = fabsl((pC->y)/((pC->x)+CERO));
	(pE->theta) = atan( temp );
if( (pC->x)<(LDBL)(0.0) && (pC->y)>(LDBL)(0.0) ) // 2o cuadrante
	{
	(pE->theta) = (LDBL)(M_PI) - (pE->theta);
	}
else if( (pC->x)<(LDBL)(0.0) && (pC->y)<(LDBL)(0.0) ) // 3er cuadrante
		{
		(pE->theta) = (LDBL)(M_PI) + (pE->theta);
		}
	  else if( (pC->x)>(LDBL)(0.0) && (pC->y)<(LDBL)(0.0) ) // 4o cuadrante
				{
				(pE->theta) = (LDBL)(M_PI)*(LDBL)(2.0) - (pE->theta);
				}

if( (pE->r)==(LDBL)(0.0) ) (pE->r) += CERO;
temp = (pC->z)/(pE->r);
pE->phi = asin( temp );

return;
}

void esf_a_cart(vector3DEsf *pE, vector3D *pC)
{
register LDBL tmp;

tmp = cos( (pE->phi) );
(pC->x) = (pE->r)*cos( (pE->theta) )*tmp;
(pC->y) = (pE->r)*sin( (pE->theta) )*tmp;
(pC->z) = (pE->r)*sin( (pE->phi) );
(pC->t) = (LDBL)1.0;

return;
}

void calculoCoefMatrCambioBase( void )
{
(mcb->tipo) = M_CAMBIO_BASE;
(mcb->f1->x) = -sin( (ojoEsf->theta) );
(mcb->f1->y) =  cos( (ojoEsf->theta) );
(mcb->f1->z) =  (LDBL)(0.0);
(mcb->f1->t) =  (LDBL)(0.0);
(mcb->f2->z) =  cos( (ojoEsf->phi) );
(mcb->f2->t) =  (LDBL)(0.0);
(mcb->f3->z) = -sin( (ojoEsf->phi) );
(mcb->f3->t) =  (ojoEsf->r);
(mcb->f2->x) =  (mcb->f1->y)*(mcb->f3->z);
(mcb->f2->y) = -(mcb->f1->x)*(mcb->f3->z);
(mcb->f3->x) = -(mcb->f1->y)*(mcb->f2->z);
(mcb->f3->y) =  (mcb->f1->x)*(mcb->f2->z);
(mcb->f4->x) =  (LDBL)(0.0);
(mcb->f4->y) =  (LDBL)(0.0);
(mcb->f4->z) =  (LDBL)(0.0);
(mcb->f4->t) =  (LDBL)(1.0);

traspuesta(mcb,inv_mcb);

(inv_mcb->tipo) = M_CAMBIO_BASE;
(inv_mcb->f1->t) = -(mcb->f3->t)*(mcb->f3->x);
(inv_mcb->f2->t) = -(mcb->f3->t)*(mcb->f3->y);
(inv_mcb->f3->t) = -(mcb->f3->t)*(mcb->f3->z);
(inv_mcb->f4->z) = (LDBL)(0.0);

return;
}

void cambioBaseCuadrica( matriz4x4 *Q, matriz4x4 *nuevaQ )
{
matriz4x4 *aux1, *aux2;

// Formula del cambio de base de una cuadrica
// (mcb^(-1))' * Q * mcb^(-1) = nuevaQ
//

aux1 = alocata_Matriz();
aux2 = alocata_Matriz();
traspuesta(inv_mcb,aux2);
	matriz_x_matriz(aux2,Q,aux1);
	matriz_x_matriz(aux1,inv_mcb,nuevaQ);
free(aux1);
free(aux2);

return;
}

void matrizPorPunto(matriz4x4 *M, vector3D *x, vector3D *y )
{
vector3D *aux;

aux = alocata_Vector();
	(aux->x) = vecDot4x4( (M->f1),x );
	(aux->y) = vecDot4x4( (M->f2),x );
	(aux->z) = vecDot4x4( (M->f3),x );
	(aux->t) = vecDot4x4( (M->f4),x );
*y = *aux;
free(aux);

return;
}

void coordUniv_a_coordOjo(vector3D *pU, vector3D *pO)
{
matrizPorPunto(mcb,pU,pO);

return;
}

LDBL jitter_x(void)
{
return( (LDBL)(-0.5)+((LDBL)(rand()))/((LDBL)(RAND_MAX)) );
}

LDBL jitter_y(void)
{
return( (LDBL)(-0.5)+((LDBL)(rand()))/((LDBL)(RAND_MAX)) );
}

void ptoTele_a_ptoPProy(int x, int y, vector3D *puntoPantalla)
{
if( jitter==Si )
	{
	(puntoPantalla->x) = -X_0 + ( (LDBL)(x) + jitter_x() )*X_inc;
	(puntoPantalla->y) =  Y_0 - ( (LDBL)(y) + jitter_y() )*Y_inc;
	}
else
	{
	(puntoPantalla->x) = -X_0 + ( (LDBL)(x) )*X_inc;
	(puntoPantalla->y) =  Y_0 - ( (LDBL)(y) )*Y_inc;
	}
(puntoPantalla->z) =  (LDBL)(1.0);
(puntoPantalla->t) =  (LDBL)(1.0);

return;
}

void calculo_VolVis(void)
{
(volVis->angVisVertical)   /= (LDBL)(2.0);
(volVis->angVisHorizontal) /= (LDBL)(2.0);
X_0 	= tan( (volVis->angVisHorizontal) );
X_inc = ( (LDBL)(2.0) * X_0 )/( (LDBL)(xRes) );
Y_0 	= tan( (volVis->angVisVertical) );
Y_inc = ( (LDBL)(2.0) * Y_0 )/( (LDBL)(yRes) );

return;
}

LDBL normaVector( vector3D *v )
{
return sqrt( (v->x)*(v->x)+(v->y)*(v->y)+(v->z)*(v->z) );
}

void escalarPorVector( LDBL k, vector3D *v, vector3D *r)
{
(r->x) = k * (v->x);
(r->y) = k * (v->y);
(r->z) = k * (v->z);

return;
}

void vectorUnitario( vector3D *v, vector3D *vUnit )
{
vector3D *aux;

aux = alocata_Vector();
escalarPorVector((LDBL)(1.0)/normaVector(v),v,aux);
*vUnit = *aux;
free(aux);

return;
}

LDBL vecDot( vector3D *v0, vector3D *v1 )
{
return( (v0->x)*(v1->x)+(v0->y)*(v1->y)+(v0->z)*(v1->z) );
}

LDBL vecDot4x4( vector3D *v0, vector3D *v1 )
{
return( (v0->x)*(v1->x)+(v0->y)*(v1->y)+(v0->z)*(v1->z)+(v0->t)*(v1->t) );
}

void vecCross( vector3D *v, vector3D *u, vector3D *vCROSSu )
{
(vCROSSu->x) = (u->y)*(v->z)-(v->y)*(u->z);
(vCROSSu->y) = (u->z)*(v->x)-(u->x)*(v->z);
(vCROSSu->z) = (u->x)*(v->y)-(u->y)*(v->x);

return;
}

void restaVector( vector3D *v0, vector3D *v1, vector3D *r)
{
vector3D *aux;

aux = alocata_Vector();
(aux->x) = (v0->x)-(v1->x);
(aux->y) = (v0->y)-(v1->y);
(aux->z) = (v0->z)-(v1->z);
(aux->t) = (LDBL)1.0;
*r = *aux;
free(aux);

return;
}

void creaVector( vector3D *p0, vector3D *p1, vector3D *v )
{
restaVector(p1,p0,v);
vectorUnitario(v,v);
(v->t) = (LDBL)1.0;

return;
}

void creaVectorNoUnitario( vector3D *p0, vector3D *p1, vector3D *v )
{
restaVector(p1,p0,v);
(v->t) = (LDBL)1.0;

return;
}

void copiaVector( vector3D *u, vector3D *v )
{
*v = *u;

return;
}

void traspuesta(matriz4x4 *A, matriz4x4 *C)
{
matriz4x4 *B;

B = alocata_Matriz();

B->f1->x = A->f1->x;
B->f1->y = A->f2->x;
B->f1->z = A->f3->x;
B->f1->t = A->f4->x;

B->f2->x = A->f1->y;
B->f2->y = A->f2->y;
B->f2->z = A->f3->y;
B->f2->t = A->f4->y;

B->f3->x = A->f1->z;
B->f3->y = A->f2->z;
B->f3->z = A->f3->z;
B->f3->t = A->f4->z;

B->f4->x = A->f1->t;
B->f4->y = A->f2->t;
B->f4->z = A->f3->t;
B->f4->t = A->f4->t;

*C = *B;


return;
}

void matriz_x_matriz(matriz4x4 *A, matriz4x4 *B, matriz4x4 *C)
{
vector3D *aux;

aux = alocata_Vector();
	aux->x = B->f1->x;
	aux->y = B->f2->x;
	aux->z = B->f3->x;
	aux->t = B->f4->x;
C->f1->x = vecDot4x4(A->f1,aux);
C->f2->x = vecDot4x4(A->f2,aux);
C->f3->x = vecDot4x4(A->f3,aux);
C->f4->x = vecDot4x4(A->f4,aux);
	aux->x = B->f1->y;
	aux->y = B->f2->y;
	aux->z = B->f3->y;
	aux->t = B->f4->y;
C->f1->y = vecDot4x4(A->f1,aux);
C->f2->y = vecDot4x4(A->f2,aux);
C->f3->y = vecDot4x4(A->f3,aux);
C->f4->y = vecDot4x4(A->f4,aux);
	aux->x = B->f1->z;
	aux->y = B->f2->z;
	aux->z = B->f3->z;
	aux->t = B->f4->z;
C->f1->z = vecDot4x4(A->f1,aux);
C->f2->z = vecDot4x4(A->f2,aux);
C->f3->z = vecDot4x4(A->f3,aux);
C->f4->z = vecDot4x4(A->f4,aux);
	aux->x = B->f1->t;
	aux->y = B->f2->t;
	aux->z = B->f3->t;
	aux->t = B->f4->t;
C->f1->t = vecDot4x4(A->f1,aux);
C->f2->t = vecDot4x4(A->f2,aux);
C->f3->t = vecDot4x4(A->f3,aux);
C->f4->t = vecDot4x4(A->f4,aux);
free(aux);

return;
}

void crea_Matriz_Inversa_Traslacion( LDBL x, LDBL y, LDBL z, matriz4x4 *m)
{
/*
	 [ 1 0 0 -x ]
m = [ 0 1 0 -y ]
	 [ 0 0 1 -z ]
	 [ 0 0 0  1 ]
*/
m->f1->x = (LDBL)(1.0);
m->f1->y = (LDBL)(0.0);
m->f1->z = (LDBL)(0.0);
m->f1->t = -x;
m->f2->x = (LDBL)(0.0);
m->f2->y = (LDBL)(1.0);
m->f2->z = (LDBL)(0.0);
m->f2->t = -y;
m->f3->x = (LDBL)(0.0);
m->f3->y = (LDBL)(0.0);
m->f3->z = (LDBL)(1.0);
m->f3->t = -z;
m->f4->x = (LDBL)(0.0);
m->f4->y = (LDBL)(0.0);
m->f4->z = (LDBL)(0.0);
m->f4->t = (LDBL)(1.0);

return;
}

void crea_Matriz_Inversa_Escalado( LDBL x, LDBL y, LDBL z, matriz4x4 *m)
{
/*
	 [ 1/x  0   0  0 ]
m = [  0  1/y  0  0 ]
	 [  0   0  1/z 0 ]
	 [  0   0   0  1 ]
*/

if( x == 0.0 ) x = 1.0;
if( y == 0.0 ) y = 1.0;
if( z == 0.0 ) z = 1.0;

m->f1->x = (LDBL)(1.0)/x;
m->f1->y = (LDBL)(0.0);
m->f1->z = (LDBL)(0.0);
m->f1->t = (LDBL)(0.0);
m->f2->x = (LDBL)(0.0);
m->f2->y = (LDBL)(1.0)/y;
m->f2->z = (LDBL)(0.0);
m->f2->t = (LDBL)(0.0);
m->f3->x = (LDBL)(0.0);
m->f3->y = (LDBL)(0.0);
m->f3->z = (LDBL)(1.0)/z;
m->f3->t = (LDBL)(0.0);
m->f4->x = (LDBL)(0.0);
m->f4->y = (LDBL)(0.0);
m->f4->z = (LDBL)(0.0);
m->f4->t = (LDBL)(1.0);

return;
}

void crea_Matriz_Inversa_Rotacion( LDBL x, LDBL y, LDBL z, matriz4x4 *m)
{
/*
	 [  ]
m = [  ]
	 [  ]
	 [  ]
*/

// Paso de grados a radianes

x = (LDBL)(x)*(LDBL)(pi)/(LDBL)(180.0);
y = (LDBL)(y)*(LDBL)(pi)/(LDBL)(180.0);
z = (LDBL)(z)*(LDBL)(pi)/(LDBL)(180.0);

m->f1->x = cos(z)*cos(y);
m->f1->y = sin(z)*cos(y);
m->f1->z = -sin(y);
m->f1->t = (LDBL)(0.0);
m->f2->x = cos(z)*sin(y)*sin(x) - sin(z)*cos(x);
m->f2->y = cos(z)*cos(x) - sin(z)*sin(y)*sin(x);
m->f2->z = cos(y)*sin(x);
m->f2->t = (LDBL)(0.0);
m->f3->x = cos(z)*sin(y)*cos(x) + sin(z)*sin(x);
m->f3->y = sin(z)*sin(y)*cos(x) - cos(z)*sin(x);
m->f3->z = cos(y)*cos(x);
m->f3->t = (LDBL)(0.0);
m->f4->x = (LDBL)(0.0);
m->f4->y = (LDBL)(0.0);
m->f4->z = (LDBL)(0.0);
m->f4->t = (LDBL)(1.0);

return;
}

void transformacion_De_Cuadrica( matriz4x4 *M, matriz4x4 *Q )
{
//       t
// Q := M * Q * M
//
// donde M ya es la inversa de la transformacion

matriz4x4 *aux1, *aux2;


aux1 = alocata_Matriz();
aux2 = alocata_Matriz();

traspuesta(M,aux1);
matriz_x_matriz(aux1,Q,aux2);
matriz_x_matriz(aux2,M,Q);

free(aux1);
free(aux2);


return;
}