#include <stdlib.h>
#include <conio.h>
#include <alloc.h>
#include <string.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include "rt_def.h"
#include "rt_func.h"
#include "rt_exter.h"
#include "tgasave.h"
#include "svga.h"

FILE *OutFile;

int recorrer_Pantalla_Con_Teclado( char *nom )
{
register int           x = 0, y = 0;
register unsigned int  contador = 0;
unsigned char  	       Red, Green, Blue;
unsigned char huge    *buffer;

if( !(buffer=(unsigned char huge *)farcalloc(xRes*3,sizeof(unsigned char))) )
	{
	SV_restoreMode();
	printf("\nError: No se pudo crear el buffer de volcado a fichero.\n");
	exit(1);
	}

if( (OutFile=fopen(nom,"wb"))==NULL )
	{
	farfree(buffer);
	SV_restoreMode();
	printf("\nError: No se pudo crear el archivo %s",nom);
	return(0);
	}
TGA_SetImageID(nom);
TGA_SetAuthor("Jose Vela");
TGA_SetSoftwareID("RAY13");
if( WriteFileHeader() != TGA_OK )
	{
	printf("\nError: No se pudo grabar la cabecera de %s",nom);
	}

// Si no hay recursividad no hay reflejos ni refracciones
if( max_Recursividad==0 )
	{
	for(pObject=listaObjetos->objetoInicial;pObject!=NULL;
		 pObject=pObject->objetoSiguiente)
		{
		copiaVector(OJO,pObject->Ks);
		copiaVector(OJO,pObject->Kt);
		}
	}
xIni = ( xMaxima - xRes ) / 2;
yIni = ( yMaxima - yRes ) / 2;
xFin = ( xIni + xRes );
yFin = ( yIni + yRes );
rectangulo(xIni,yIni,xFin-1,yFin-1,SV_rgbColor(255,255,255)); // rect blanco
SV_beginPixel();
for(y=yIni;y<yFin;y++)
	{
	for(x=xIni;x<xFin;x++)
		{
		if( kbhit() )
			{
			fwrite((unsigned char huge *)buffer,sizeof(unsigned char),contador,OutFile);
			farfree(buffer);
			SV_endPixel();
			if( WriteFileFooter() != TGA_OK )
				{
				printf("\nError: No se pudo grabar el pie de %s",nom);
				}
			fclose(OutFile);
			if( remove(nom) )
				{
				printf("Error: No se pudo borrar %s (imagen incompleta)",nom);
				}
			return(0);
			}
		nPrimarios++;
		ptoTele_a_ptoPProy(x-xIni,y-yIni,puntoPantalla);
		// Rayo_Primario->origen = OJO;
		copiaVector(puntoPantalla,(Rayo_Primario->dir));
		Rayo_Primario->tipo = PRIMARIO;
		Rayo_Primario->iR   = iR_Aire;
		Rayo_Primario->d     = 0.0;	// Distancia recorrida
		copia_Color(color_NEGRO,(Rayo_Primario->color));
		traza_Rayo(Rayo_Primario,0);	// Nivel de recursividad  0
		escalar_Por_Color(d_att(Rayo_Primario->d),(Rayo_Primario->color));
		actualiza_Cota_Color((Rayo_Primario->color));
		normaliza_Color((Rayo_Primario->color));
		Red   = (uchar)(255*Rayo_Primario->color->r);
		Green = (uchar)(255*Rayo_Primario->color->g);
		Blue  = (uchar)(255*Rayo_Primario->color->b);
		SV_putPixelFast(x,y,SV_rgbColor(Red,Green,Blue));
		buffer[contador] = Blue;
		contador++;
		buffer[contador] = Green;
		contador++;
		buffer[contador] = Red;
		contador++;
		}
	fwrite((unsigned char huge *)buffer,sizeof(unsigned char),contador,OutFile);
	contador = 0;
	}
farfree(buffer);
SV_endPixel();
if( WriteFileFooter() != TGA_OK )
	{
	printf("\nError: No se pudo grabar el pie de %s",nom);
	}
fclose(OutFile);

return(1);
}

int recorrer_Pantalla_Sin_Teclado( char *nom )
{
register int           x = 0, y = 0;
register unsigned int  contador = 0;
unsigned char  	       Red, Green, Blue;
unsigned char huge    *buffer;

if( !(buffer=(unsigned char huge *)farcalloc(xRes*3,sizeof(unsigned char))) )
	{
	SV_restoreMode();
	printf("\nError: No se pudo crear el buffer de volcado a fichero.\n");
	exit(1);
	}

if( (OutFile=fopen(nom,"wb"))==NULL )
	{
	farfree(buffer);
	SV_restoreMode();
	printf("\nError: No se pudo crear el archivo %s",nom);
	return(0);
	}
TGA_SetImageID(nom);
TGA_SetAuthor("Jose Vela");
TGA_SetSoftwareID("RAY13");
if( WriteFileHeader() != TGA_OK )
	{
	printf("\nError: No se pudo grabar la cabecera de %s",nom);
	}

// Si no hay recursividad no hay reflejos ni refracciones
if( max_Recursividad==0 )
	{
	for(pObject=listaObjetos->objetoInicial;pObject!=NULL;
		 pObject=pObject->objetoSiguiente)
		{
		copiaVector(OJO,pObject->Ks);
		copiaVector(OJO,pObject->Kt);
		}
	}
xIni = ( xMaxima - xRes ) / 2;
yIni = ( yMaxima - yRes ) / 2;
xFin = ( xIni + xRes );
yFin = ( yIni + yRes );
rectangulo(xIni,yIni,xFin-1,yFin-1,SV_rgbColor(255,255,255)); // rect blanco
SV_beginPixel();
for(y=yIni;y<yFin;y++)
	{
	for(x=xIni;x<xFin;x++)
		{
		nPrimarios++;
		ptoTele_a_ptoPProy(x-xIni,y-yIni,puntoPantalla);
		// Rayo_Primario->origen = OJO;
		copiaVector(puntoPantalla,(Rayo_Primario->dir));
		Rayo_Primario->tipo = PRIMARIO;
		Rayo_Primario->iR   = iR_Aire;
		Rayo_Primario->d    = 0.0;	// Distancia recorrida
		copia_Color(color_NEGRO,(Rayo_Primario->color));
		traza_Rayo(Rayo_Primario,0);	// Nivel de recursividad  0
		escalar_Por_Color(d_att(Rayo_Primario->d),(Rayo_Primario->color));
		actualiza_Cota_Color((Rayo_Primario->color));
		normaliza_Color((Rayo_Primario->color));
		Red   = (uchar)(255*Rayo_Primario->color->r);
		Green = (uchar)(255*Rayo_Primario->color->g);
		Blue  = (uchar)(255*Rayo_Primario->color->b);
		SV_putPixelFast(x,y,SV_rgbColor(Red,Green,Blue));
		buffer[contador] = Blue;
		contador++;
		buffer[contador] = Green;
		contador++;
		buffer[contador] = Red;
		contador++;
		}
	fwrite((unsigned char huge *)buffer,sizeof(unsigned char),contador,OutFile);
	contador = 0;
	}
farfree(buffer);
SV_endPixel();
if( WriteFileFooter() != TGA_OK )
	{
	printf("\nError: No se pudo grabar el pie de %s",nom);
	}
fclose(OutFile);

return(1);
}

void rectangulo(int x0, int y0, int x1, int y1, unsigned long int color)
{
SV_beginLine();
SV_lineFast(x0,y0,x1,y0,color); // arriba
SV_lineFast(x0,y1,x1,y1,color); // abajo
SV_lineFast(x0,y0,x0,y1,color); // derecha
SV_lineFast(x1,y0,x1,y1,color); // izquierda
SV_endLine();

return;
}

void traza_Rayo(rayo *r, int recursividad)
{
if( calculaInterseccion(r) )	   /* Hay interseccin ? */
	{
		/* Clculo de la normal en el pto de interseccion */

	normalCuadrica((intersec->objeto->ecuacion),(intersec->pto),
						(intersec->normal));

		/* Clculo de la luz del rayo */

	sombra_Rayo(r,recursividad);
	}
else  /* No hay interseccin  ->  colorRayo = colorFondo */
	{

	copia_Color(color_Fondo,(r->color));
	}

return;
}

void sombra_Rayo(rayo *r, int recursividad)
{
extern int intersecExterna;
LDBL 		  dot_N_L=0.0, dot_R_V=0.0, dot_N_I=0.0, dot_N_V=0.0, taux=0.0,
			  dFoco=0.0, delta=0.0, theta_i=0.0, theta_t=0.0, ks=0.0, kt=0.0;

	/* Clculo del color ambiental */

if( c_ambiental==Si )
	{
	copia_Color((intersec->objeto->color_difuso),color_Ambiental);
	escalar_Por_Color((intersec->objeto->Ka),color_Ambiental);
	producto_Color(luz_Ambiental,color_Ambiental);
	suma_Color(color_Ambiental,(r->color));
	}

	/* Clculo del color aportado por las luces */

creaVector((intersec->pto),OJO,V);
if( c_luces==Si )
	{
	copiaVector((intersec->pto),(r_s->origen));
	r_s->tipo = SOMBRA;
	(r_s->iR) = iR_Aire;
	(r_s->d)  = 0.0;
	for(pLight=listaFocos->focoInicial;pLight!=NULL;
		 pLight=pLight->focoSiguiente)
		{
		creaVectorNoUnitario((intersec->pto),(pLight->origen),(r_s->dir));
		dFoco = normaVector(r_s->dir);
		vectorUnitario((r_s->dir),(r_s->dir));		// L = r_s->dir
		copia_Color(color_NEGRO,(r_s->color));
		dot_N_L = vecDot((intersec->normal),(r_s->dir));
		escalarPorVector(( (LDBL)(2.0)*dot_N_L ),(intersec->normal),R);
		restaVector(R,(r_s->dir),R);
		vectorUnitario(R,R);
		dot_R_V = vecDot(R,V);
		if( dot_N_L>(LDBL)(0.0) )
			{
				/* Clculo del color difuso */

			copia_Color((intersec->objeto->color_difuso),color_Difuso);
			escalar_Por_Color( ((intersec->objeto->Kd)*dot_N_L ),color_Difuso);
			producto_Color((pLight->intensidad),color_Difuso);
			suma_Color(color_Difuso,(r_s->color));

				/* Calculo del color especular */

			if( dot_R_V>(LDBL)(0.0) )
				{
				copia_Color(intersec->objeto->color_especular,color_Especular);
				escalar_Por_Color(((intersec->objeto->Kh)*
										 pow(dot_R_V,(intersec->objeto->n))),
										 color_Especular);
				producto_Color((pLight->intensidad),color_Especular);
				suma_Color(color_Especular,(r_s->color));
				}

				/* Clculo del factor de atenuacin del foco por la distancia */

			escalar_Por_Color(f_att(pLight,dFoco),(r_s->color));

				/* Clculo de las intersecsecciones de la luz con los objetos */

			if( sombras==Si )
				{
				XYZ_a_Vector3D(1.0,1.0,1.0,s);
				for(pObject=listaObjetos->objetoInicial;
					 pObject!=NULL;
					 pObject=pObject->objetoSiguiente)
					{
					nSombra++;
					intersec_Cuadrica_y_Rayo_Secundario((pObject->ecuacion),r_s);
					if( tmin_tmax->x<CERO )
						{
						if( tmin_tmax->y<CERO )	taux = 0.0;
						else taux = tmin_tmax->y;
						}
					else taux = tmin_tmax->x;
					if( taux>CERO && taux<dFoco )
						{
						nSombraHit++;
						(r_s->d) += taux;
						s->x *= (pObject->Kt->x);
						s->y *= (pObject->Kt->y);
						s->z *= (pObject->Kt->z);
						}
					}

				escalar_Por_Color(d_att(r_s->d),(r_s->color));
				producto_Color(s,(r_s->color));
				}
			}

		suma_Color((r_s->color),(r->color));
		}
	}

if( recursividad<max_Recursividad )
	{
	ks = normaVector((intersec->objeto->Ks));
	if( ks>(LDBL)(0.0) )
		{
		copiaVector((intersec->objeto->Ks),Ks);
		copiaVector((intersec->pto),(r_r->origen));
		dot_N_V = vecDot((intersec->normal),V);
		escalarPorVector((LDBL)(2.0)*dot_N_V,(intersec->normal),(r_r->dir));
		restaVector((r_r->dir),V,(r_r->dir));
		vectorUnitario((r_r->dir),(r_r->dir));
		(r_r->tipo) = REFLEJADO;
		(r_r->iR)   = iR_Aire;
		}

	kt = normaVector((intersec->objeto->Kt));
	if( kt>(LDBL)(0.0) )
		{
		copiaVector((intersec->objeto->Kt),Kt);
		copiaVector((intersec->pto),(r_t->origen));
		escalarPorVector((LDBL)(-1.0),(r->dir),I);
		vectorUnitario(I,I);
		if( (r->iR)==(intersec->objeto->iR) )
			{
			intersecExterna = 0;
			dot_N_I = -1.0;
			theta_i = (r->iR)/iR_Aire;
			}
		else
			{
			intersecExterna = 1;
			dot_N_I = 1.0;
			theta_i = (r->iR)/(intersec->objeto->iR);
			}
		dot_N_I *= vecDot((intersec->normal),I);
		theta_t = (LDBL)(1.0)/theta_i;
		delta = (LDBL)(1.0)-(theta_t*theta_t)*((LDBL)(1.0)-(dot_N_I*dot_N_I));
		if( delta>(LDBL)(0.0) )
			{
			if( intersecExterna==0 )
				{
				escalarPorVector(-(theta_i*dot_N_I-sqrt(delta)),
										(intersec->normal),(r_t->dir));
				}
			else
				{
				escalarPorVector(theta_i*dot_N_I-sqrt(delta),
									  (intersec->normal),(r_t->dir));
				}
			escalarPorVector(theta_i,I,I);
			restaVector((r_t->dir),I,(r_t->dir));
			vectorUnitario((r_t->dir),(r_t->dir));
			}
		else copiaVector(OJO,Kt);
		(r_t->tipo) = REFRACTADO;
		(r_t->iR)   = (intersec->objeto->iR);
		}

	if( recursividad==0 )
		{
		copia_Color(color_NEGRO,(r_r->color));
		(r_r->d) = 0.0;
		copia_Color(color_NEGRO,(r_t->color));
		(r_t->d) = 0.0;
		}

	if( ks>(LDBL)(0.0) && reflexiones==Si && c_luces==Si )
		{
		nReflejados++;
		traza_Rayo(r_r,(recursividad+1));
		escalar_Por_Color(d_att(r_r->d),(r_r->color));
		producto_Color(Ks,(r_r->color));
		suma_Color((r_r->color),(r->color));
		}
	if( kt>(LDBL)(0.0) && delta>(LDBL)(0.0) &&
		 refracciones==Si && c_luces==Si )
		{
		nRefractados++;
		traza_Rayo(r_t,(recursividad+1));
		escalar_Por_Color(d_att(r_t->d),(r_t->color));
		producto_Color(Kt,(r_t->color));
		suma_Color((r_t->color),(r->color));
		}
	}

return;
}

// Funciones auxiliares para almacenar imagenes en formato TARGA

int Write(void *buf, unsigned len)
{
fwrite(buf, sizeof(Byte), len, OutFile);

return TGA_OK;
}

int WriteByte(Byte b)
{
putc(b, OutFile);

return TGA_OK;
}

int WriteWord(Word w)
{
putc(w & 0xFF, OutFile);
putc((w >> 8), OutFile);

return TGA_OK;
}

int WriteZeros(int n)
{
while( n-- ) putc(0, OutFile);

return TGA_OK;
}

int WriteFileHeader(void)
{
if( WriteByte(strlen(ImageID)) != TGA_OK ) return TGA_ERRWRITE;
if( WriteByte(0) != TGA_OK ) return TGA_ERRWRITE;
if( WriteByte(2) != TGA_OK ) return TGA_ERRWRITE;
if( WriteZeros(5) != TGA_OK ) return TGA_ERRWRITE;
if( WriteWord(0) != TGA_OK || WriteWord(0) != TGA_OK ) return TGA_ERRWRITE;
if( WriteWord(xRes-0) != TGA_OK || WriteWord(yRes-0) != TGA_OK ) return TGA_ERRWRITE;
if( WriteByte(24) != TGA_OK || WriteByte(32) != TGA_OK ) return TGA_ERRWRITE;
if( Write(ImageID, strlen(ImageID)) != TGA_OK )	return TGA_ERRWRITE;

return TGA_OK;
}

int WriteFileFooter(void)
{
long extoffs = 0L;

if( strlen(Author) || strlen(SoftwareID) || AspectHeight )
	{
	extoffs = ftell(OutFile);
	if( WriteWord(495) != TGA_OK ) return TGA_ERRWRITE;
	if( Write(Author, sizeof(Author)) != TGA_OK ) return TGA_ERRWRITE;
	if( WriteZeros( 324      // Author Comments
		       + 12      // Date/Time Stamp
		       + 41      // Job Name_ID
		       +  6      // Job Time
		      ) != TGA_OK ) return TGA_ERRWRITE;
	if( Write(SoftwareID, sizeof(SoftwareID)) != TGA_OK ) return TGA_ERRWRITE;
	if( WriteZeros(  3       // Software Version
		       + 4       // Key Color
		      ) != TGA_OK)  return TGA_ERRWRITE;
	if( WriteWord(AspectWidth) != TGA_OK ||
		 WriteWord(AspectHeight) != TGA_OK ) return TGA_ERRWRITE;
	if( WriteZeros(  4       // Gamma Value
		       + 4       // Color Correction Offset
		       + 4       // Postage Stamp Offset
		       + 1       // Attributs Type
		      ) != TGA_OK ) return TGA_ERRWRITE;
	}
if( WriteWord((Word)extoffs) != TGA_OK ) return TGA_ERRWRITE;
if( WriteWord(0L) != TGA_OK ) return TGA_ERRWRITE;
if( Write("TRUEVISION-XFILE.", 18) != TGA_OK ) return TGA_ERRWRITE;

return TGA_OK;
}

void TGA_SetImageID(char *s)
{
memset(ImageID, 0, sizeof(ImageID));
strncpy(ImageID, s, sizeof(ImageID) - 1);
}

void TGA_SetAuthor(char *s)
{
memset(Author, 0, sizeof(Author));
strncpy(Author, s, sizeof(Author) - 1);
}

void TGA_SetSoftwareID(char *s)
{
memset(SoftwareID, 0, sizeof(SoftwareID));
strncpy(SoftwareID, s, sizeof(SoftwareID) - 1);
}

void TGA_SetAspect(int width, int height)
{
AspectWidth = width;
AspectHeight = height;
}
